]> asedeno.scripts.mit.edu Git - git.git/blob - git-rebase.sh
7d1c5c3861f6c3d760ff99a8c3b5a4287edddd34
[git.git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
5
6 USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] (<upstream>|--root) [<branch>] [--quiet | -q]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name.  When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
12
13 It is possible that a merge failure will prevent this process from being
14 completely automatic.  You will have to resolve any such merge failure
15 and run git rebase --continue.  Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip.  To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
19
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
22
23 Example:       git-rebase master~1 topic
24
25         A---B---C topic                   A'\''--B'\''--C'\'' topic
26        /                   -->           /
27   D---E---F---G master          D---E---F---G master
28 '
29
30 SUBDIRECTORY_OK=Yes
31 OPTIONS_SPEC=
32 . git-sh-setup
33 set_reflog_action rebase
34 require_work_tree
35 cd_to_toplevel
36
37 LF='
38 '
39 OK_TO_SKIP_PRE_REBASE=
40 RESOLVEMSG="
41 When you have resolved this problem run \"git rebase --continue\".
42 If you would prefer to skip this patch, instead run \"git rebase --skip\".
43 To restore the original branch and stop rebasing run \"git rebase --abort\".
44 "
45 unset newbase
46 strategy=recursive
47 strategy_opts=
48 do_merge=
49 dotest="$GIT_DIR"/rebase-merge
50 prec=4
51 verbose=
52 diffstat=$(git config --bool rebase.stat)
53 git_am_opt=
54 rebase_root=
55 force_rebase=
56 allow_rerere_autoupdate=
57
58 continue_merge () {
59         test -n "$prev_head" || die "prev_head must be defined"
60         test -d "$dotest" || die "$dotest directory does not exist"
61
62         unmerged=$(git ls-files -u)
63         if test -n "$unmerged"
64         then
65                 echo "You still have unmerged paths in your index"
66                 echo "did you forget to use git add?"
67                 die "$RESOLVEMSG"
68         fi
69
70         cmt=`cat "$dotest/current"`
71         if ! git diff-index --quiet --ignore-submodules HEAD --
72         then
73                 if ! git commit --no-verify -C "$cmt"
74                 then
75                         echo "Commit failed, please do not call \"git commit\""
76                         echo "directly, but instead do one of the following: "
77                         die "$RESOLVEMSG"
78                 fi
79                 if test -z "$GIT_QUIET"
80                 then
81                         printf "Committed: %0${prec}d " $msgnum
82                 fi
83                 echo "$cmt $(git rev-parse HEAD^0)" >> "$dotest/rewritten"
84         else
85                 if test -z "$GIT_QUIET"
86                 then
87                         printf "Already applied: %0${prec}d " $msgnum
88                 fi
89         fi
90         test -z "$GIT_QUIET" &&
91         GIT_PAGER='' git log --format=%s -1 "$cmt"
92
93         prev_head=`git rev-parse HEAD^0`
94         # save the resulting commit so we can read-tree on it later
95         echo "$prev_head" > "$dotest/prev_head"
96
97         # onto the next patch:
98         msgnum=$(($msgnum + 1))
99         echo "$msgnum" >"$dotest/msgnum"
100 }
101
102 call_merge () {
103         cmt="$(cat "$dotest/cmt.$1")"
104         echo "$cmt" > "$dotest/current"
105         hd=$(git rev-parse --verify HEAD)
106         cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
107         msgnum=$(cat "$dotest/msgnum")
108         end=$(cat "$dotest/end")
109         eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
110         eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
111         export GITHEAD_$cmt GITHEAD_$hd
112         if test -n "$GIT_QUIET"
113         then
114                 export GIT_MERGE_VERBOSITY=1
115         fi
116         eval 'git-merge-$strategy' $strategy_opts '"$cmt^" -- "$hd" "$cmt"'
117         rv=$?
118         case "$rv" in
119         0)
120                 unset GITHEAD_$cmt GITHEAD_$hd
121                 return
122                 ;;
123         1)
124                 git rerere $allow_rerere_autoupdate
125                 die "$RESOLVEMSG"
126                 ;;
127         2)
128                 echo "Strategy: $rv $strategy failed, try another" 1>&2
129                 die "$RESOLVEMSG"
130                 ;;
131         *)
132                 die "Unknown exit code ($rv) from command:" \
133                         "git-merge-$strategy $cmt^ -- HEAD $cmt"
134                 ;;
135         esac
136 }
137
138 move_to_original_branch () {
139         test -z "$head_name" &&
140                 head_name="$(cat "$dotest"/head-name)" &&
141                 onto="$(cat "$dotest"/onto)" &&
142                 orig_head="$(cat "$dotest"/orig-head)"
143         case "$head_name" in
144         refs/*)
145                 message="rebase finished: $head_name onto $onto"
146                 git update-ref -m "$message" \
147                         $head_name $(git rev-parse HEAD) $orig_head &&
148                 git symbolic-ref HEAD $head_name ||
149                 die "Could not move back to $head_name"
150                 ;;
151         esac
152 }
153
154 finish_rb_merge () {
155         move_to_original_branch
156         git notes copy --for-rewrite=rebase < "$dotest"/rewritten
157         if test -x "$GIT_DIR"/hooks/post-rewrite &&
158                 test -s "$dotest"/rewritten; then
159                 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
160         fi
161         rm -r "$dotest"
162         say All done.
163 }
164
165 is_interactive () {
166         while test $# != 0
167         do
168                 case "$1" in
169                         -i|--interactive)
170                                 interactive_rebase=explicit
171                                 break
172                         ;;
173                         -p|--preserve-merges)
174                                 interactive_rebase=implied
175                         ;;
176                 esac
177                 shift
178         done
179
180         if [ "$interactive_rebase" = implied ]; then
181                 GIT_EDITOR=:
182                 export GIT_EDITOR
183         fi
184
185         test -n "$interactive_rebase" || test -f "$dotest"/interactive
186 }
187
188 run_pre_rebase_hook () {
189         if test -z "$OK_TO_SKIP_PRE_REBASE" &&
190            test -x "$GIT_DIR/hooks/pre-rebase"
191         then
192                 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
193                 die "The pre-rebase hook refused to rebase."
194         fi
195 }
196
197 test -f "$GIT_DIR"/rebase-apply/applying &&
198         die 'It looks like git-am is in progress. Cannot rebase.'
199
200 is_interactive "$@" && exec git-rebase--interactive "$@"
201
202 while test $# != 0
203 do
204         case "$1" in
205         --no-verify)
206                 OK_TO_SKIP_PRE_REBASE=yes
207                 ;;
208         --continue)
209                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
210                         die "No rebase in progress?"
211
212                 git diff-files --quiet --ignore-submodules || {
213                         echo "You must edit all merge conflicts and then"
214                         echo "mark them as resolved using git add"
215                         exit 1
216                 }
217                 if test -d "$dotest"
218                 then
219                         prev_head=$(cat "$dotest/prev_head")
220                         end=$(cat "$dotest/end")
221                         msgnum=$(cat "$dotest/msgnum")
222                         onto=$(cat "$dotest/onto")
223                         GIT_QUIET=$(cat "$dotest/quiet")
224                         continue_merge
225                         while test "$msgnum" -le "$end"
226                         do
227                                 call_merge "$msgnum"
228                                 continue_merge
229                         done
230                         finish_rb_merge
231                         exit
232                 fi
233                 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
234                 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
235                 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
236                 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
237                 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
238                 move_to_original_branch
239                 exit
240                 ;;
241         --skip)
242                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
243                         die "No rebase in progress?"
244
245                 git reset --hard HEAD || exit $?
246                 if test -d "$dotest"
247                 then
248                         git rerere clear
249                         prev_head=$(cat "$dotest/prev_head")
250                         end=$(cat "$dotest/end")
251                         msgnum=$(cat "$dotest/msgnum")
252                         msgnum=$(($msgnum + 1))
253                         onto=$(cat "$dotest/onto")
254                         GIT_QUIET=$(cat "$dotest/quiet")
255                         while test "$msgnum" -le "$end"
256                         do
257                                 call_merge "$msgnum"
258                                 continue_merge
259                         done
260                         finish_rb_merge
261                         exit
262                 fi
263                 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
264                 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
265                 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
266                 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
267                 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
268                 move_to_original_branch
269                 exit
270                 ;;
271         --abort)
272                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
273                         die "No rebase in progress?"
274
275                 git rerere clear
276                 if test -d "$dotest"
277                 then
278                         GIT_QUIET=$(cat "$dotest/quiet")
279                         move_to_original_branch
280                 else
281                         dotest="$GIT_DIR"/rebase-apply
282                         GIT_QUIET=$(cat "$dotest/quiet")
283                         move_to_original_branch
284                 fi
285                 git reset --hard $(cat "$dotest/orig-head")
286                 rm -r "$dotest"
287                 exit
288                 ;;
289         --onto)
290                 test 2 -le "$#" || usage
291                 newbase="$2"
292                 shift
293                 ;;
294         -M|-m|--m|--me|--mer|--merg|--merge)
295                 do_merge=t
296                 ;;
297         -X*|--strategy-option*)
298                 case "$#,$1" in
299                 1,-X|1,--strategy-option)
300                         usage ;;
301                 *,-X|*,--strategy-option)
302                         newopt="$2"
303                         shift ;;
304                 *,--strategy-option=*)
305                         newopt="$(expr " $1" : ' --strategy-option=\(.*\)')" ;;
306                 *,-X*)
307                         newopt="$(expr " $1" : ' -X\(.*\)')" ;;
308                 1,*)
309                         usage ;;
310                 esac
311                 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--$newopt")"
312                 do_merge=t
313                 if test -n "$strategy"
314                 then
315                         strategy=recursive
316                 fi
317                 ;;
318         -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
319                 --strateg=*|--strategy=*|\
320         -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
321                 case "$#,$1" in
322                 *,*=*)
323                         strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
324                 1,*)
325                         usage ;;
326                 *)
327                         strategy="$2"
328                         shift ;;
329                 esac
330                 do_merge=t
331                 ;;
332         -n|--no-stat)
333                 diffstat=
334                 ;;
335         --stat)
336                 diffstat=t
337                 ;;
338         -v|--verbose)
339                 verbose=t
340                 diffstat=t
341                 GIT_QUIET=
342                 ;;
343         -q|--quiet)
344                 GIT_QUIET=t
345                 git_am_opt="$git_am_opt -q"
346                 verbose=
347                 diffstat=
348                 ;;
349         --whitespace=*)
350                 git_am_opt="$git_am_opt $1"
351                 case "$1" in
352                 --whitespace=fix|--whitespace=strip)
353                         force_rebase=t
354                         ;;
355                 esac
356                 ;;
357         --ignore-whitespace)
358                 git_am_opt="$git_am_opt $1"
359                 ;;
360         --committer-date-is-author-date|--ignore-date)
361                 git_am_opt="$git_am_opt $1"
362                 force_rebase=t
363                 ;;
364         -C*)
365                 git_am_opt="$git_am_opt $1"
366                 ;;
367         --root)
368                 rebase_root=t
369                 ;;
370         -f|--f|--fo|--for|--forc|force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase|--no-ff)
371                 force_rebase=t
372                 ;;
373         --rerere-autoupdate|--no-rerere-autoupdate)
374                 allow_rerere_autoupdate="$1"
375                 ;;
376         -*)
377                 usage
378                 ;;
379         *)
380                 break
381                 ;;
382         esac
383         shift
384 done
385 test $# -gt 2 && usage
386
387 if test $# -eq 0 && test -z "$rebase_root"
388 then
389         test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
390         test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
391                 die 'A rebase is in progress, try --continue, --skip or --abort.'
392 fi
393
394 # Make sure we do not have $GIT_DIR/rebase-apply
395 if test -z "$do_merge"
396 then
397         if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
398         then
399                 rmdir "$GIT_DIR"/rebase-apply
400         else
401                 echo >&2 '
402 It seems that I cannot create a rebase-apply directory, and
403 I wonder if you are in the middle of patch application or another
404 rebase.  If that is not the case, please
405         rm -fr '"$GIT_DIR"'/rebase-apply
406 and run me again.  I am stopping in case you still have something
407 valuable there.'
408                 exit 1
409         fi
410 else
411         if test -d "$dotest"
412         then
413                 die "previous rebase directory $dotest still exists." \
414                         'Try git rebase (--continue | --abort | --skip)'
415         fi
416 fi
417
418 # The tree must be really really clean.
419 if ! git update-index --ignore-submodules --refresh > /dev/null; then
420         echo >&2 "cannot rebase: you have unstaged changes"
421         git diff-files --name-status -r --ignore-submodules -- >&2
422         exit 1
423 fi
424 diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
425 case "$diff" in
426 ?*)     echo >&2 "cannot rebase: your index contains uncommitted changes"
427         echo >&2 "$diff"
428         exit 1
429         ;;
430 esac
431
432 if test -z "$rebase_root"
433 then
434         # The upstream head must be given.  Make sure it is valid.
435         upstream_name="$1"
436         shift
437         upstream=`git rev-parse --verify "${upstream_name}^0"` ||
438         die "invalid upstream $upstream_name"
439         unset root_flag
440         upstream_arg="$upstream_name"
441 else
442         test -z "$newbase" && die "--root must be used with --onto"
443         unset upstream_name
444         unset upstream
445         root_flag="--root"
446         upstream_arg="$root_flag"
447 fi
448
449 # Make sure the branch to rebase onto is valid.
450 onto_name=${newbase-"$upstream_name"}
451 case "$onto_name" in
452 *...*)
453         if      left=${onto_name%...*} right=${onto_name#*...} &&
454                 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
455         then
456                 case "$onto" in
457                 ?*"$LF"?*)
458                         die "$onto_name: there are more than one merge bases"
459                         ;;
460                 '')
461                         die "$onto_name: there is no merge base"
462                         ;;
463                 esac
464         else
465                 die "$onto_name: there is no merge base"
466         fi
467         ;;
468 *)
469         onto=$(git rev-parse --verify "${onto_name}^0") || exit
470         ;;
471 esac
472
473 # If a hook exists, give it a chance to interrupt
474 run_pre_rebase_hook "$upstream_arg" "$@"
475
476 # If the branch to rebase is given, that is the branch we will rebase
477 # $branch_name -- branch being rebased, or HEAD (already detached)
478 # $orig_head -- commit object name of tip of the branch before rebasing
479 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
480 switch_to=
481 case "$#" in
482 1)
483         # Is it "rebase other $branchname" or "rebase other $commit"?
484         branch_name="$1"
485         switch_to="$1"
486
487         if git show-ref --verify --quiet -- "refs/heads/$1" &&
488            branch=$(git rev-parse -q --verify "refs/heads/$1")
489         then
490                 head_name="refs/heads/$1"
491         elif branch=$(git rev-parse -q --verify "$1")
492         then
493                 head_name="detached HEAD"
494         else
495                 usage
496         fi
497         ;;
498 *)
499         # Do not need to switch branches, we are already on it.
500         if branch_name=`git symbolic-ref -q HEAD`
501         then
502                 head_name=$branch_name
503                 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
504         else
505                 head_name="detached HEAD"
506                 branch_name=HEAD ;# detached
507         fi
508         branch=$(git rev-parse --verify "${branch_name}^0") || exit
509         ;;
510 esac
511 orig_head=$branch
512
513 # Now we are rebasing commits $upstream..$branch (or with --root,
514 # everything leading up to $branch) on top of $onto
515
516 # Check if we are already based on $onto with linear history,
517 # but this should be done only when upstream and onto are the same.
518 mb=$(git merge-base "$onto" "$branch")
519 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
520         # linear history?
521         ! (git rev-list --parents "$onto".."$branch" | sane_grep " .* ") > /dev/null
522 then
523         if test -z "$force_rebase"
524         then
525                 # Lazily switch to the target branch if needed...
526                 test -z "$switch_to" || git checkout "$switch_to"
527                 say "Current branch $branch_name is up to date."
528                 exit 0
529         else
530                 say "Current branch $branch_name is up to date, rebase forced."
531         fi
532 fi
533
534 # Detach HEAD and reset the tree
535 say "First, rewinding head to replay your work on top of it..."
536 git checkout -q "$onto^0" || die "could not detach HEAD"
537 git update-ref ORIG_HEAD $branch
538
539 if test -n "$diffstat"
540 then
541         if test -n "$verbose"
542         then
543                 echo "Changes from $mb to $onto:"
544         fi
545         # We want color (if set), but no pager
546         GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
547 fi
548
549 # If the $onto is a proper descendant of the tip of the branch, then
550 # we just fast-forwarded.
551 if test "$mb" = "$branch"
552 then
553         say "Fast-forwarded $branch_name to $onto_name."
554         move_to_original_branch
555         exit 0
556 fi
557
558 if test -n "$rebase_root"
559 then
560         revisions="$onto..$orig_head"
561 else
562         revisions="$upstream..$orig_head"
563 fi
564
565 if test -z "$do_merge"
566 then
567         git format-patch -k --stdout --full-index --ignore-if-in-upstream \
568                 $root_flag "$revisions" |
569         git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
570         move_to_original_branch
571         ret=$?
572         test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
573                 echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
574                 echo $onto > "$GIT_DIR"/rebase-apply/onto &&
575                 echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head &&
576                 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply/quiet
577         exit $ret
578 fi
579
580 # start doing a rebase with git-merge
581 # this is rename-aware if the recursive (default) strategy is used
582
583 mkdir -p "$dotest"
584 echo "$onto" > "$dotest/onto"
585 echo "$onto_name" > "$dotest/onto_name"
586 prev_head=$orig_head
587 echo "$prev_head" > "$dotest/prev_head"
588 echo "$orig_head" > "$dotest/orig-head"
589 echo "$head_name" > "$dotest/head-name"
590 echo "$GIT_QUIET" > "$dotest/quiet"
591
592 msgnum=0
593 for cmt in `git rev-list --reverse --no-merges "$revisions"`
594 do
595         msgnum=$(($msgnum + 1))
596         echo "$cmt" > "$dotest/cmt.$msgnum"
597 done
598
599 echo 1 >"$dotest/msgnum"
600 echo $msgnum >"$dotest/end"
601
602 end=$msgnum
603 msgnum=1
604
605 while test "$msgnum" -le "$end"
606 do
607         call_merge "$msgnum"
608         continue_merge
609 done
610
611 finish_rb_merge